unit ADDA2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CPort, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    lblStat: TLabel;
    btConnect: TButton;
    cmdSetting: TButton;
    ComPort: TComPort;
    btRun: TButton;
    trInput: TTrackBar;
    rd2V: TRadioButton;
    rd5V: TRadioButton;
    txtChannel: TEdit;
    Timer1: TTimer;
    txtChannelADC: TEdit;
    Image1: TImage;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    lblBaca: TLabel;
    lblChannelStat: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    lbl2V: TLabel;
    Bevel1: TBevel;
    procedure cmdSettingClick(Sender: TObject);
    procedure btConnectClick(Sender: TObject);
    procedure btRunClick(Sender: TObject);
    procedure DAC(Channel:integer;Input:integer;Range:integer);
    procedure rd2VClick(Sender: TObject);
    procedure rd5VClick(Sender: TObject);
    procedure bacaPortA;
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const data=$40;
const clk=$42;
const ldac=$44;
const load=$46;
const a0=$50;
const a1=$52;
const a2=$54;
const wr=$56;
const rd=$58;
const io=$5a;
const cs=$5c;
const time=2;
const time2=10;

var
  Form1: TForm1;
  ack:integer;
  intinput:integer;

implementation

{$R *.DFM}

procedure TForm1.cmdSettingClick(Sender: TObject);
begin
        comport.ShowSetupDialog;
end;

procedure TForm1.btConnectClick(Sender: TObject);
begin
     if ComPort.Connected then
        begin
        ComPort.Close;
        btConnect.Caption:='Connect' ;
        lblStat.Caption:=ComPort.Port+' Disconnected';
        cmdSetting.Enabled:=true;
        btRun.Enabled:=false;
        timer1.Enabled:=false;
        end
     else
        begin
        ComPort.Open;
        btConnect.Caption:='Disconnect';
        lblStat.Caption:=ComPort.Port+' Connected';
        cmdSetting.Enabled:=false;
        btRun.Enabled:=true;
        timer1.Enabled:=true;
        end;
end;

procedure TForm1.btRunClick(Sender: TObject);
var  Range:integer;
     panjang:integer;
begin
    if rd5V.Checked then Range:=1
    else Range:=0;
    if txtChannel.Text<'8' then
     begin
      if txtChannel.Text>='0' then
      begin
        panjang:=trinput.Position*255;
        DAC(strtoint(txtChannel.text),panjang div 25,Range);
        lblChannelStat.Caption:='Channel Correct';
      end;
     end
    else
        lblChannelStat.Caption:='Out Of Range'

end;

procedure TForm1.DAC(Channel:integer;Input:integer;Range:Integer);
var
        pembagi:integer;
        i:integer;
        j:integer;
begin
        comport.WriteStr(chr(load+1));
        sleep(2);
        comport.WriteStr(chr(ldac+1));
        sleep(2);

        pembagi:=$4;
        for j:=1 to 3 do
        begin
          i:=(Channel and pembagi)div pembagi;
          Comport.WriteStr(Chr(clk+1));
          sleep (time);
          Comport.WriteStr(Chr(data+i));
          sleep (time);
          Comport.WriteStr(Chr(clk));
          sleep (time);
          pembagi:=pembagi div 2
        end;

        i:=Range and 1;
        Comport.WriteStr(Chr(clk+1));
        sleep (time);
        Comport.WriteStr(Chr(data+i));
        sleep (time);
        Comport.WriteStr(Chr(clk));
        sleep (time);

        pembagi:=$80;
        for j:=1 to 8 do
        begin
          i:=(Input and pembagi)div pembagi;
          Comport.WriteStr(Chr(clk+1));
          sleep (time);
          Comport.WriteStr(Chr(data+i));
          sleep (time);
          Comport.WriteStr(Chr(clk));
          sleep (time);
          pembagi:=pembagi div 2
        end;

        comport.WriteStr(chr(load+0));
        sleep(2);
        comport.WriteStr(chr(ldac+0));
        sleep(2);
end;

procedure TForm1.rd2VClick(Sender: TObject);
begin
        lbl2V.Caption:='2,5V'
end;

procedure TForm1.rd5VClick(Sender: TObject);
begin
        lbl2V.Caption:='5V'
end;

procedure TForm1.bacaPortA;
begin
        comport.WriteStr(chr($26));
        sleep(time2);
        comport.Read(ack,1);
        sleep(time2);
        comport.WriteStr(chr($99));
        comport.ClearBuffer(true,false);
        sleep(time2);
        comport.WriteStr(chr($21));
        sleep(time2);
        comport.Read(ack,1);
        comport.Read(intinput,1);
        lblBaca.Caption:= 'Tegangan Input ADC = '+
        inttostr(intinput*2 div 100)+','+inttostr(intinput*2 mod 100)+' V';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if txtChannelADC.Text<'8' then
    if txtChannelADC.Text>='0' then
     begin
       comport.WriteStr(chr(cs));
       sleep(time2);
       comport.WriteStr(chr(a0+(strtoint(txtChannelADC.Text) and 1)));
       sleep(time2);
       comport.WriteStr(chr(a1+((strtoint(txtChannelADC.Text) and 2)div 2)));
       sleep(time2);
       comport.WriteStr(chr(a2+((strtoint(txtChannelADC.Text) and 4)div 4)));
       sleep(time2);
       comport.WriteStr(chr(wr));
       sleep(time2);
       comport.WriteStr(chr(wr+1));
       sleep(time2);
       comport.WriteStr(chr(wr));
       sleep(time2);
       comport.WriteStr(chr(rd));
       sleep(time2);
       comport.WriteStr(chr(rd+1));
       sleep(time2);
       comport.WriteStr(chr(rd));
       sleep(time2);
       bacaPortA;
       sleep(time2);
     end;
end;

end.
